; PCC Printer Definition for Postscript printers.
;
; This is my first attempt ever to generate something looking
; like Postscript. Beware, I never read a book on that subject...
; Ghostscript eats it and displays it correct. Foreign
; characters (Char128..Char255) are made by "overprinting", although
; this doesn't always work for capital letters.
;
; Note that overly complex pages (e.g., using many foreign chars)
; may generate invalid Postscript due to the current 255 character
; limit in a string.
;
; All you Postscript gurus out there would probably have done it
; completely different and much better. Especially the underline
; code is weird. If you have a better driver, please drop me
; a note...

Desc            Postscript

; Y ... current Y position
; P ... font size in points (10 points to fit PCC's assumption for
;       96 chars/line, 12 for 80 c/l)
; Q ... flag if there's already text on this page
; O ... Text used for overprinting
Init            Y:=800;P:=10;Q:=0;O:="";"%!"+LF+"/CB{/Courier-Bold findfont "&P&" scalefont setfont}def /CN{/Courier findfont "&P&" scalefont setfont}def CN 1 setlinewidth 40 "&Y&" moveto /UL{dup stringwidth pop 0 rlineto stroke 3 1 roll moveto}def"&LF
Done            IF(Q, LF+"showpage", "")+LF
Newline         Y:=Y-P-2;O:=""; IF(Y<60, Y:=800;Q:=0; LF+"showpage"+LF, LF)+"40 "&Y&" moveto "
Normal          Q:=1; IF(TRIM(O), "currentpoint("&RTRIM(O)&")show moveto","") & "(" & S & ")show "&(O:="")
Bold            Q:=1; "CB "&IF(TRIM(O),"currentpoint("&RTRIM(O)&")show moveto","")&"(" & S & ")show CN "&(O:="")
Underline       Q:=1; IF(TRIM(O), "currentpoint("&RTRIM(O)&")show moveto ","")&"currentpoint 0 -1 rmoveto("&S&")UL show"
;dup stringwidth pop 0 rlineto stroke 3 1 roll moveto show"
;&"currentpoint currentpoint 1 sub moveto("&S&")stringwidth pop 0 rlineto stroke moveto(" & S & ")show "&(O:="")

; Note that the _last_ matching definition is used, so Char0-255 is a
; catch-all rule
Char0-127       O:=O+" "; S
Char128-255     O:=O+" "; "#"
Char"("         O:=O+" "; "\("
Char")"         O:=O+" "; "\)"
Char"\"         O:=O+" "; "\\"
Char"`"         O:=O+" "; "\301"
Char128         O:=O+"\313"; "C"
Char129         O:=O+"\310"; "u"
Char130         O:=O+"\302"; "e"
Char131         O:=O+"\303"; "a"
Char132         O:=O+"\310"; "a"
Char133         O:=O+"\301"; "a"
Char134         O:=O+"\312"; "a"
Char135         O:=O+"\313"; "c"
Char136         O:=O+"\303"; "e"
Char137         O:=O+"\310"; "e"
Char138         O:=O+"\301"; "e"
Char139         O:=O+"\310"; "\365"
Char140         O:=O+"\303"; "\365"
Char141         O:=O+"\301"; "\365"
Char142         O:=O+"\310"; "A"
Char143         O:=O+"\312"; "A"
Char144         O:=O+"\302"; "E"
Char145         O:=O+" "; "\361"
Char146         O:=O+" "; "\341"
Char147         O:=O+"\303"; "o"
Char148         O:=O+"\310"; "o"
Char149         O:=O+"\301"; "o"
Char150         O:=O+"\303"; "u"
Char151         O:=O+"\301"; "u"
Char152         O:=O+"\310"; "y"
Char153         O:=O+"\310"; "O"
Char154         O:=O+"\310"; "U"
Char155         O:=O+" "; "\242"
Char156         O:=O+" "; "\243"
Char157         O:=O+" "; "\245"
Char158         O:=O+"  "; "Pt"
Char159         O:=O+" "; "\246"
Char160         O:=O+"\302"; "a"
Char161         O:=O+"\302"; "\365"
Char162         O:=O+"\302"; "o"
Char163         O:=O+"\302"; "u"
Char164         O:=O+"\304"; "n"
Char165         O:=O+"\304"; "N"
Char166         O:=O+" "; "\343"
Char167         O:=O+" "; "\353"
Char168         O:=O+" "; "\277"
Char173         O:=O+" "; "\241"
Char174         O:=O+" "; "\253"
Char175         O:=O+" "; "\273"
Char176-223     O:=O+" "; "+"
Char179         O:=O+" "; "|"
Char186         O:=O+" "; "|"
Char196         O:=O+" "; "-"
Char205         O:=O+" "; "="
Char225         O:=O+" "; "\373"
Char237         O:=O+" "; "\371"
Char241         O:=O+"_"; "+"
Char242         O:=O+"_"; ">"
Char243         O:=O+"_"; "<"
Char248         O:=O+" "; "\312"
Char249         O:=O+" "; "\267"
Char250         O:=O+" "; "\264"
